import java.io.*;
import java.util.*;

public class Arknave {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String[] s = new String[3];
        for (int i = 0; i < 3; i++) {
            s[i] = br.readLine();
        }
        int n = s[0].length();

        // store all rotations of the third string.
        Map<String, Integer> rotations = new HashMap<>();
        {
            String cur = s[2];
            for (int i = 0; i < n; i++) {
                rotations.put(cur, Math.min(i, rotations.getOrDefault(cur, n)));
                cur = cur.substring(1) + cur.charAt(0);
            }
        }

        int ans = Integer.MAX_VALUE;

        // rotate the first string
        for (int r = 0; r < n; r++) {
            // match up the strings
            boolean valid = true;
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < n; i++) {
                char a = s[0].charAt((r + i) % n);
                char b = s[1].charAt(i);
                if (a == b) {
                    valid = false;
                    break;
                } else {
                    sb.append((char)('A' ^ 'B' ^ 'C' ^ a ^ b));
                }
            }

            String row = sb.toString();
            if (valid && rotations.containsKey(row)) {
                int k = rotations.get(row);
                // we've rotated 1 by r and 3 by k.
                for (int b = 0; b < n; ++b) {
                    int[] rots = new int[]{(r + b) % n, b, (k + b) % n};
                    int cur = 0;
                    for (int rot : rots) {
                        cur += Math.min(rot, n - rot);
                    }

                    ans = Math.min(ans, cur);
                }
            }
        }

        if (ans == Integer.MAX_VALUE) {
            ans = -1;
        }

        System.out.println(ans);
    }
}
