import java.util.*;
import java.lang.Math.*;

public class Bryce {

  static int n;
  static final int INF = 1000000000;

  static boolean works(String one, String two, int twoOffset) {
    for (int i = 0; i < n; ++i) {
      int twoIdx = (i+twoOffset)%n;
      if (one.charAt(i) == two.charAt(twoIdx))
        return false;
    }
    return true;
  }

  static void getWorkingShifts(String one, String two, ArrayList<Integer> shifts) {
    for (int i = 0; i < n; ++i) {
      if (works(one, two, i)) {
        shifts.add(i);
      }
    }
  }

  static int bestWay(int input) {
    return Math.min(input, n-input);
  }

  static int solve(String wheelOne, String wheelTwo, String wheelThree) {
    ArrayList<Integer> twoShifts = new ArrayList<Integer>();
    ArrayList<Integer> threeShifts = new ArrayList<Integer>();
    ArrayList<Integer> consistencies = new ArrayList<Integer>();

    getWorkingShifts(wheelOne, wheelTwo, twoShifts);
    getWorkingShifts(wheelTwo, wheelThree, threeShifts);
    getWorkingShifts(wheelOne, wheelThree, consistencies);
    HashSet<Integer> consistent = new HashSet<Integer>();
    for (int item : consistencies) {
      consistent.add(item);
    }

    int best = INF;
    for (int twoShift : twoShifts) {
      for (int threeShift : threeShifts) {
        int offset = (twoShift + threeShift)%n;
        if (consistent.contains(offset)) {
          best = Math.min(best, bestWay(twoShift) + bestWay(offset));
        }
      }
    }
    return best;
  }

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    String wheelOne = in.nextLine();
    String wheelTwo = in.nextLine();
    String wheelThree = in.nextLine();
    n = wheelOne.length();

    int best = INF;
    best = Math.min(best, solve(wheelOne, wheelTwo, wheelThree));
    best = Math.min(best, solve(wheelTwo, wheelThree, wheelOne));
    best = Math.min(best, solve(wheelThree, wheelOne, wheelTwo));
    if (best == INF) {
      best = -1;
    }
    System.out.println(best);
  }
}
