import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.io.BufferedWriter;
import java.util.HashMap;
import java.util.Random;
import java.util.InputMismatchException;
import java.io.IOException;
import java.util.stream.Stream;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.Optional;
import java.math.BigInteger;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author lewin
 */
public class letter_wheels_lewin_n_log_n {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        LetterWheelsHard solver = new LetterWheelsHard();
        solver.solve(1, in, out);
        out.close();
    }

    static class LetterWheelsHard {
        String a;
        String b;
        String c;
        int n;

        public void solve(int testNumber, InputReader in, OutputWriter out) {
            a = in.next();
            b = in.next();
            c = in.next();

            n = a.length();
//        n = 300000;
//        char[] xa = new char[n], xb = new char[n], xc = new char[n];
//        for (int i = 0; i < n; i++) {
//            char[] d = new char[]{'A', 'B', 'C'};
//            AUtils.shuffle(d);
//            xa[i] = d[0]; xb[i] = d[1]; xc[i] = d[2];
//        }
//        a = new String(xa); b = new String(xb); c = new String(xc);
//        int ai = (int)(Math.random()*n);
//        a = a.substring(ai) + a.substring(0, ai);
//        int bi = (int)(Math.random()*n);
//        b = b.substring(bi) + b.substring(0, bi);
//        int ci = (int)(Math.random()*n);
//        c = c.substring(ci) + c.substring(0, ci);
//        System.out.println(ai+" "+bi+" "+ci);
//        int realans = f(ai) + f(bi) + f(ci);
//        realans = Math.min(realans, f((bi - ai + n) % n) + f((ci - ai + n) % n));
//        realans = Math.min(realans, f((ai - bi + n) % n) + f((ci - bi + n) % n));
//        realans = Math.min(realans, f((bi - ci + n) % n) + f((ai - ci + n) % n));
//        System.out.println(realans);
            long start = System.currentTimeMillis();
            long[] matches = new long[n];
            int[] x1 = new int[n + n], x2 = new int[n];
            for (char i = 'A'; i <= 'C'; i++) {
                for (int j = 0; j < n; j++) {
                    x1[j] = x1[j + n] = (a.charAt(j) == i ? 1 : 0);
                    x2[j] = (b.charAt(n - j - 1) == i ? 1 : 0);
                }
                int[] r = FFT.multiply(x1, x2);
                for (int j = 0; j < n; j++) {
                    matches[j] += r[j + n - 1];
                }
            }

            Hashing h1 = new Hashing(a + a);
            Hashing h2 = new Hashing(b + b);
            Hashing h3 = new Hashing(c + c);
            long all1 = 0, all2 = 0;
            for (int i = 0; i < n; i++) {
                all1 = (all1 * Hashing.multiplier + 'A' + 'B' + 'C') % Hashing.mod1;
                all2 = (all2 * Hashing.multiplier + 'A' + 'B' + 'C') % Hashing.mod2;
            }
            HashMap<Long, Integer> idx1 = new HashMap<>();
            HashMap<Long, Integer> idx2 = new HashMap<>();
            int ans = Integer.MAX_VALUE;
            for (int i = 0; i < n; i++) {
                if (matches[i] == 0) {
                    long mhash1 = h1.getHash(i, n);
                    long mhash2 = h2.getHash(0, n);
                    long top = (all1 - (mhash1 >> 32L) - (mhash2 >> 32L) + 2 * Hashing.mod1) % Hashing.mod1;
                    long bot = (all2 - (mhash1 & ((1L << 32) - 1)) - (mhash2 & ((1L << 32) - 1)) + 2 * Hashing.mod2) % Hashing.mod2;
                    long mhash = (top << 32) + bot;
                    idx1.putIfAbsent(mhash, i);
                    idx2.put(mhash, i);
                }
            }
            for (int i = 0; i < n; i++) {
                long b = h3.getHash(i, n);
                if (idx1.containsKey(b)) {
                    int[] js = {idx1.get(b), idx2.get(b)};
                    for (int j : js) {
                        int k = (i - j + n) % n;
                        int ii = Math.min(i, n - i);
                        int jj = Math.min(j, n - j);
                        int kk = Math.min(k, n - k);
                        ans = AUtils.min(ans, ii + jj, jj + kk, kk + ii);
                    }
                }
            }
            out.println(ans == Integer.MAX_VALUE ? -1 : ans);
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(int i) {
            writer.println(i);
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public String next() {
            int c;
            while (isSpaceChar(c = this.read())) {
                ;
            }

            StringBuilder result = new StringBuilder();
            result.appendCodePoint(c);

            while (!isSpaceChar(c = this.read())) {
                result.appendCodePoint(c);
            }

            return result.toString();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }

    static class AUtils {
        public static <E extends Comparable<E>> E min(E... arr) {
            return Arrays.stream(arr).min(E::compareTo).get();
        }

    }

    static class Hashing {
        public static final int multiplier = 43;
        public static final Random rnd = new Random();
        public static final int mod1 = BigInteger.valueOf((int) (5e8 + rnd.nextInt((int) 5e8))).nextProbablePrime().intValue();
        public static final int mod2 = BigInteger.valueOf((int) (5e8 + rnd.nextInt((int) 5e8))).nextProbablePrime().intValue();
        public static final int invMultiplier1 = BigInteger.valueOf(multiplier).modInverse(BigInteger.valueOf(mod1)).intValue();
        public static final int invMultiplier2 = BigInteger.valueOf(multiplier).modInverse(BigInteger.valueOf(mod2)).intValue();
        long[] hash1;
        long[] hash2;
        long[] inv1;
        long[] inv2;
        int n;

        public Hashing(String s) {
            n = s.length();
            hash1 = new long[n + 1];
            hash2 = new long[n + 1];
            inv1 = new long[n + 1];
            inv2 = new long[n + 1];
            inv1[0] = 1;
            inv2[0] = 1;

            long p1 = 1;
            long p2 = 1;
            for (int i = 0; i < n; i++) {
                hash1[i + 1] = (hash1[i] + s.charAt(i) * p1) % mod1;
                p1 = p1 * multiplier % mod1;
                inv1[i + 1] = inv1[i] * invMultiplier1 % mod1;
                hash2[i + 1] = (hash2[i] + s.charAt(i) * p2) % mod2;
                p2 = p2 * multiplier % mod2;
                inv2[i + 1] = inv2[i] * invMultiplier2 % mod2;
            }
        }

        public long getHash(int i, int len) {
            return (((hash1[i + len] - hash1[i] + mod1) * inv1[i] % mod1) << 32)
                    + (hash2[i + len] - hash2[i] + mod2) * inv2[i] % mod2;
        }

    }

    static class FFT {
        public static void fft(double[] a, double[] b, boolean invert) {
            int n = a.length;
            int shift = 32 - Integer.numberOfTrailingZeros(n);
            for (int i = 1; i < n; i++) {
                int j = Integer.reverse(i << shift);
                if (i < j) {
                    double temp = a[i];
                    a[i] = a[j];
                    a[j] = temp;
                    temp = b[i];
                    b[i] = b[j];
                    b[j] = temp;
                }
            }
            for (int len = 2; len <= n; len <<= 1) {
                int halfLen = len >> 1;
                double angle = 2 * Math.PI / len * (invert ? -1 : 1);
                double wLenA = Math.cos(angle);
                double wLenB = Math.sin(angle);
                for (int i = 0; i < n; i += len) {
                    double wA = 1;
                    double wB = 0;
                    for (int j = 0; j < halfLen; j++) {
                        double uA = a[i + j];
                        double uB = b[i + j];
                        double vA = a[i + j + halfLen] * wA - b[i + j + halfLen] * wB;
                        double vB = a[i + j + halfLen] * wB + b[i + j + halfLen] * wA;
                        a[i + j] = uA + vA;
                        b[i + j] = uB + vB;
                        a[i + j + halfLen] = uA - vA;
                        b[i + j + halfLen] = uB - vB;
                        double nextWA = wA * wLenA - wB * wLenB;
                        wB = wA * wLenB + wB * wLenA;
                        wA = nextWA;
                    }
                }
            }
            if (invert) {
                for (int i = 0; i < n; i++) {
                    a[i] /= n;
                    b[i] /= n;
                }
            }
        }

        public static int[] multiply(int[] a, int[] b) {
            int resultSize = Integer.highestOneBit(Math.max(a.length, b.length) - 1) << 2;
            resultSize = Math.max(resultSize, 2);
            double[] aReal = new double[resultSize];
            double[] aImaginary = new double[resultSize];
            double[] bReal = new double[resultSize];
            double[] bImaginary = new double[resultSize];
            for (int i = 0; i < a.length; i++)
                aReal[i] = a[i];
            for (int i = 0; i < b.length; i++)
                bReal[i] = b[i];
            _fft2(aReal, bReal, aImaginary, bImaginary, false);
            for (int i = 0; i < resultSize; i++) {
                double real = aReal[i] * bReal[i] - aImaginary[i] * bImaginary[i];
                aImaginary[i] = aImaginary[i] * bReal[i] + bImaginary[i] * aReal[i];
                aReal[i] = real;
            }
            fft(aReal, aImaginary, true);
            int[] result = new int[resultSize];
            for (int i = 0; i < resultSize; i++) {
                result[i] = (int) (Math.round(aReal[i]));
            }
            return result;
        }

        public static void _fft2(double[] a, double[] b, double[] aim, double[] bim, boolean invert) {
            // assumes a and b have only real coefficients
            int n = a.length;
            double[] pReal = Arrays.copyOf(a, n);
            double[] pImaginary = Arrays.copyOf(b, n);
            fft(pReal, pImaginary, invert);
            if (invert) {
                for (int i = 0; i < n; i++) {
                    a[i] = pReal[i];
                    aim[i] = 0;
                    b[i] = pImaginary[i];
                    bim[i] = 0;
                }
            } else {
                a[0] = pReal[0];
                aim[0] = 0;
                b[0] = pImaginary[0];
                bim[0] = 0;
                for (int i = 1; i < n; i++) {
                    a[i] = (pReal[i] + pReal[n - i]) / 2.0;
                    aim[i] = (pImaginary[i] - pImaginary[n - i]) / 2.0;

                    b[i] = (pImaginary[i] + pImaginary[n - i]) / 2.0;
                    bim[i] = -(pReal[i] - pReal[n - i]) / 2.0;
                }
            }
        }

    }
}


