from collections import defaultdict
import sys

input = lambda: sys.stdin.readline().strip()

def extra(x, y):
    for c in 'ABC':
        if c != x and c != y:
            return c
    return None

def cost(n, k):
    ans = float('inf');
    for i in range(n):
        j = (i + k) % n
        ans = min(ans, min(i, n - i) + min(j, n - j))

    return ans

def solve(a, b, c):
    """a is fixed in place. Find the min rotations of b and c that align it with a."""
    n = len(a)
    c_rots = defaultdict(lambda: float('inf'))
    for i in range(n):
        c_rot = c[i:] + c[:i]
        c_rots[c_rot] = min(c_rots[c_rot], i, n - i)

    ans = float('inf')
    for b_off in range(n):
        res = []
        valid = True
        for i in range(n):
            x, y = a[i], b[(b_off + i) % n]
            if x == y:
                valid = False
                break
            res.append(extra(x, y))
        if not valid:
            continue

        res = ''.join(res)
        if res in c_rots:
            ans = min(ans, min(b_off, n - b_off) + c_rots[res])

    return ans

def main():
    s = [input() for _ in range(3)]

    ans = min(
        solve(s[0], s[1], s[2]),
        solve(s[1], s[0], s[2]),
        solve(s[2], s[0], s[1])
    )

    if ans == float('inf'):
        ans = -1

    print(ans)

if __name__ == '__main__':
    main()
